/*
 * CrudContainer
 * Copyright (C) 2011 by Apaq
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package dk.apaq.filter.core;

import dk.apaq.filter.Filter;
import dk.apaq.filter.FiltrationItem;
import java.util.Collection;

/**
 * Filter that retrieves the results for its subfilters and then returns a logic
 * OR for them.
 */
public class OrFilter extends AbstractFilterContainer {

    public OrFilter() {
    }

    public OrFilter(Filter ... filter) {
        super(filter);
    }

    public OrFilter(Collection<Filter> filters) {
        super(filters);
    }

    @Override
    public boolean passesFilter(FiltrationItem item) {
        if(item == null) {
                return false;
        }

        for(Filter filter : getFilters()) {
            if(filter.passesFilter(item)) {
                return true;
            }
        }
        return false;
    }
}
